// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	simple test of Proxy class
//

#include <iostream>
#include <vector>
#include "Proxy.h"

#include <cassert>

extern Proxy<int> f(Proxy<int> &p);
Proxy<int> f(Proxy<int> &p) { return p; }

extern Proxy<int> pglob;
Proxy<int> pglob;

int main()
{
	{
		Proxy<int> i;
	}
	{
		Proxy<int> p0 = new int(999);
		assert(*p0 == 999);
		{
			Proxy<int> p1 = p0;
			Proxy<int> p2(p1);
			pglob = p2;
			{
				Proxy<int> p = f(pglob);
				pglob = p;
				*p = 888;
			}
		}
	}
	assert(*pglob == 888);

	return 0;
}
